Redmine - Feature #30459

Switch edit/preview tabs with keyboard shortcuts
2019-01-18 03:02 - Mizuki ISHIKAWA

Status: Closed Start date:
Priority: Normal Due date:
Assignee: Go MAEDA % Done: 0%
Category: ul Estimated time: 0.00 hour
Target version: 4.2.0
Resolution: Fixed
Description
In Redmine 3.4 and earlier, you could update the preview with keybord shortcuts.
RedmineKeyboardNavigation: | Key Description
r Updates the preview in editor mode

| want to switch Edit/Preview tabs with keybord shortcuts.
Github:
github_shortcut.gif

Related issues:

Related to Redmine - Feature #27758: Adds preview option to the wiki toolbar Closed
Related to Redmine - Patch #34444: Remove unused key :preview from Redmine::A... Closed
Blocks Redmine - Feature #34549: Add keyboard shortcuts for wiki toolbar buttons Closed

Associated revisions

Revision 20706 - 2021-01-07 06:39 - Go MAEDA
Add keyboard shortcut to toggle between Edit/Preview tabs (#30459).

Patch by Marius BALTEANU.

Revision 20707 - 2021-01-07 06:43 - Go MAEDA
Adding system tests for keyboard shortcuts (#30459).

Patch by Marius BALTEANU.

History

#1 - 2019-01-18 06:54 - Bernhard Rohloff

| remember this topic was also discussed in the original feature. The problem was that there can be multiple editors on a single view and the
implemented accesskeys are not able to determine which editor is in focus at the moment. We would need a proper hotkey system beforehand to
make this happen.

#2 - 2019-01-18 11:53 - Marius BALTEANU

Bernhard Rohloff wrote:
| remember this topic was also discussed in the original feature. The problem was that there can be multiple editors on a single view and the
implemented accesskeys are not able to determine which editor is in focus at the moment. We would need a proper hotkey system beforehand
to make this happen.

Yes, is on the to do list to implement something custom using JS.

Mizuki, do you have some working code? or you have in plan to work on this? just to know in order to not double work on this.

#3 - 2019-01-21 01:27 - Mizuki ISHIKAWA

Bernhard Rohloff wrote:

| remember this topic was also discussed in the original feature.
| have not noticed it. Thank you for the information.
Discussion related to this topic: #27758#note-21

Marius BALTEANU wrote:

Mizuki, do you have some working code? or you have in plan to work on this? just to know in order to not double work on this.

| have no plans to work for the implementation of this feature.

#4 - 2019-01-21 07:24 - Marius BALTEANU
- Assignee set to Marius BALTEANU

#5 - 2019-04-02 07:56 - Marius BALTEANU
- Related to Feature #27758: Adds preview option to the wiki toolbar added

#6 - 2019-09-25 00:42 - Marius BALTEANU
Which should be the keyboard shortcuts here?

#7 - 2020-10-20 13:21 - Robert Schneider
Oh yes! It would be really helpful if this is possible again with wiki pages.
The problem was that there can be multiple editors on a single view and the implemented accesskeys are not able to determine which editor is in

focus at the moment.

| don't know anything about implementation, but | would be surprised if determining the right editor is that hard. Shouldn't it be
document.activeElement?

#8 - 2020-12-12 13:43 - Marius BALTEANU

- Tracker changed from Defect to Feature

#9 - 2020-12-14 03:18 - Go MAEDA
- Related to Patch #34444: Remove unused key :preview from Redmine::AccessKeys::ACCESSKEYS added

#10 - 2020-12-27 23:14 - Marius BALTEANU
- File switch_edit_preview_tabs using_keyboard_shortcuts.patch added

- Assignee deleted (Marius BALTEANU)

The attached patch adds [I/Ctrl + Shift + P keyboard shortcut to toggle between Edit/Preview tabs. This keyboard shortcut is used by both Github and
Gitlab.

| don't think that it's worth it to keep also the old shortcut (r).

Any feedback is welcome.

#11 - 2020-12-27 23:14 - Marius BALTEANU
- Assignee set to Marius BALTEANU

#12 - 2020-12-28 03:58 - Mizuki ISHIKAWA
- File switch_edit_preview _tabs_using_keyboard_shortcuts-v2.patch added
Marius BALTEANU wrote:

The attached patch adds [I/Ctrl + Shift + P keyboard shortcut to toggle between Edit/Preview tabs. This keyboard shortcut is used by both Github
and Gitlab.

| don't think that it's worth it to keep also the old shortcut (r).

Any feedback is welcome.

Thank you for sharing the patch!
| checked the operation of the patch you posted and noticed that there were cases where an exception occurred.
Reproduction procedure:

e Open preview tab with mouse click
« Try to switch from the Preview tab to the Edit tab with the shortcut key 0/Ctrl + Shift + P
e " Uncaught TypeError: Cannot read property 'find' of undefined" is outputed in the developer tools console.

If lastJstPreviewed is undefined, | think you should use jst.

diff --git a/public/javascripts/jstoolbar/jstoolbar.js b/public/javascripts/jstoolbar/jstoolbar. js
index 64a7be754..7a363lala 100644
-—- a/public/javascripts/jstoolbar/jstoolbar. js
+++ b/public/javascripts/jstoolbar/jstoolbar. js
@@ -519,8 +519,8 @@ $(document) .keydown (function(e) {
jst.find('.tab-preview') .click();
lastJstPreviewed = jst

} else {
= lastJstPreviewed.find('.tab-edit"') .click();
lastJstPreviewed.find ('textarea') .focus();
+ (lastJstPreviewed || jst).find('.tab-edit').click();
+ (lastJstPreviewed || Jjst).find('textarea').focus();

lastJstPreviewed = null;

| agree with changing the shortcut keys(r to /Ctrl + Shift + P).

#13 - 2021-01-02 21:59 - Marius BALTEANU
- File 0001-Add-keyboard-shortcut-to-toggle-between-Edit-Preview.patch added
- Assignee deleted (Marius BALTEANU)

- Target version set to 4.2.0

Thanks Mizuki for testing the patch and for reporting the issue found.

The patch was made only for testing purposes and to validate the new shortcut. Please find attached a new version of the patch which is ready from
my point of view.

Keyboard shortcuts implemented:

e Ctrl + Shift + P
e Command + Shift + P

I've tested this on the following browsers and it works as expected:
e Chrome (osx)
e Safari (0sx)
¢ Firefox (osx)
¢ Edge (windows)

Let's discuss this for 4.2.0.

#14 - 2021-01-02 22:24 - Marius BALTEANU
- File deleted (0001-Add-keyboard-shortcut-to-toggle-between-Edit-Preview.patch)

#15 - 2021-01-02 22:25 - Marius BALTEANU
- File 0001-Add-keyboard-shortcut-to-toggle-between-Edit-Preview.patch added

Just a small change to lowercase the key.

#16 - 2021-01-02 22:25 - Marius BALTEANU
- File deleted (0001-Add-keyboard-shortcut-to-toggle-between-Edit-Preview.patch)

#17 - 2021-01-02 22:26 - Marius BALTEANU
- File 0001-Add-keyboard-shortcut-to-toggle-between-Edit-Preview.patch added

#18 - 2021-01-06 06:32 - Mizuki ISHIKAWA
| tried running a new patch. Looks good.
Tested environment:

e Chrome Beta (MacOS Big Sur)
¢ |[E11 in Virtualbox Windows8

Structurally, | think it's good because it works only when there is a jstoolbar.

#19 - 2021-01-06 22:06 - Marius BALTEANU
- File 0002-Adding-system-tests.patch added

Adding system tests for this feature.

#20 - 2021-01-06 23:17 - Marius BALTEANU
- Blocks Feature #34549: Add keyboard shortcuts for wiki toolbar buttons added

#21 - 2021-01-07 06:44 - Go MAEDA
- Status changed from New to Closed
- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patch. Thank you for your contribution.

#22 - 2021-02-04 05:38 - Go MAEDA

- Subject changed from Switch edit/preview tabs with keybord shortcuts to Switch edit/preview tabs with keyboard shortcuts

#23 - 2021-11-02 22:09 - Jonathan Cormier
Tried this with Firefox 93.0 Linux, and ctrl-shift-p opens Firefox's private browsing. ctrl-shift-p does work fine in chrome.
Does anyone else have this issue?

#24 - 2021-11-16 17:55 - Marcin Szewczyk

Jonathan Cormier wrote:

Tried this with Firefox 93.0 Linux, and ctrl-shift-p opens Firefox's private browsing. ctrl-shift-p does work fine in chrome.

Does anyone else have this issue?

Yes, | observe the issue as well (Firefox on Linux). Note however that you can also use Shift+Meta+P which with proper keyboard layout configuration

can be the same as Shift+Win+P.

Files

github_shortcut.gif 296 KB 2019-01-18 Mizuki ISHIKAWA
switch_edit_preview_tabs_using_keyboard_shortcuts.patch 957 Bytes 2020-12-27 Marius BALTEANU
switch_edit_preview_tabs_using_keyboard_shortcuts-v2.patch 975 Bytes 2020-12-28 Mizuki ISHIKAWA
0001-Add-keyboard-shortcut-to-toggle-between-Edit-Preview.patch ~ 3.06 KB 2021-01-02 Marius BALTEANU
0002-Adding-system-tests.patch 3.58 KB 2021-01-06 Marius BALTEANU
